MODULE diags_unstructured_mod
  USE ISO_C_BINDING
  USE OMP_LIB
  USE data_unstructured_mod
  USE transfer_unstructured_mod
  IMPLICIT NONE
  PRIVATE
  SAVE

CONTAINS

#include "unstructured.h90"

#define HASNAN(field) (ANY(.NOT.ABS(field)<1e20))

   SUBROUTINE wind_centered(un, uxyz) BINDC(wind_centered)
     FIELD_THETA  :: uxyz ! OUT
     FIELD_U      :: un    ! IN, normal components
     !$OMP PARALLEL NUM_THREADS(nb_threads)
     CALL update_halo(transfer_edge, un)
     CALL compute_wind_centered(un,uxyz)
     !$OMP END PARALLEL
   END SUBROUTINE wind_centered

   SUBROUTINE compute_wind_centered(ue, ucenter)
     FIELD_THETA  :: ucenter ! OUT
     FIELD_U      :: ue    ! IN, normal components
     DECLARE_INDICES
     DECLARE_EDGES
     NUM :: cx, cy, cz, ux, uy, uz, ue_le, fac
     NUM, parameter :: scale = 1.
#include "../kernels_unst/wind_centered.k90"
   END SUBROUTINE compute_wind_centered

   
 END MODULE diags_unstructured_mod
